package jalview.analysis;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertSame;

import org.junit.Test;

import jalview.datamodel.DBRefEntry;

public class CrossRefTest
{
  @Test
  public void testFindXDbRefs()
  {
    DBRefEntry ref1 = new DBRefEntry("UNIPROT", "1", "A123");
    DBRefEntry ref2 = new DBRefEntry("UNIPROTKB/TREMBL", "1", "A123");
    DBRefEntry ref3 = new DBRefEntry("pdb", "1", "A123");
    DBRefEntry ref4 = new DBRefEntry("EMBLCDSPROTEIN", "1", "A123");
    DBRefEntry ref5 = new DBRefEntry("embl", "1", "A123");
    DBRefEntry ref6 = new DBRefEntry("emblCDS", "1", "A123");
    DBRefEntry ref7 = new DBRefEntry("GeneDB", "1", "A123");
    DBRefEntry ref8 = new DBRefEntry("PFAM", "1", "A123");
    DBRefEntry[] refs = new DBRefEntry[]
    { ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8 };

    /*
     * Just the DNA refs:
     */
    DBRefEntry[] found = CrossRef.findXDbRefs(false, refs);
    assertEquals(3, found.length);
    assertSame(ref5, found[0]);
    assertSame(ref6, found[1]);
    assertSame(ref7, found[2]);

    /*
     * Just the protein refs:
     */
    found = CrossRef.findXDbRefs(true, refs);
    assertEquals(4, found.length);
    assertSame(ref1, found[0]);
    assertSame(ref2, found[1]);
    assertSame(ref3, found[2]);
    assertSame(ref4, found[3]);
  }

}
